//$--perfmon.h---------------------------------------------------------------
//
//  Module:     perfmon.h
//
//  Copyright (C) Microsoft Corporation, 1985 - 1996.
//
//  Contents:   
//
//  Classes:    
//
//  Functions:  
//
//  History:    
//
//----------------------------------------------------------------------------
#ifndef __perfmon_h__
#define __perfmon_h__

// IMC Object

#define OBJECT_MSEXCHANGEIMC                         0

// Counters for MTS-IN

#define COUNTER_MESSAGES_IN_MTS_IN                   2
#define COUNTER_BYTES_IN_MTS_IN                      4
#define COUNTER_MESSAGES_ENTERING_MTS_IN             6

// Counters for MTS-OUT

#define COUNTER_MESSAGES_IN_MTS_OUT                  8
#define COUNTER_BYTES_IN_MTS_OUT                    10
#define COUNTER_MESSAGES_ENTERING_MTS_OUT           12
#define COUNTER_MESSAGES_LEAVING_MTS_OUT            14

// Counters for Associations

#define COUNTER_ASSOCIATIONS_IN                     16
#define COUNTER_ASSOCIATIONS_OUT                    18
#define COUNTER_ASSOCIATIONS_OUTTOTAL               20
#define COUNTER_ASSOCIATIONS_ACCEPTED               22
#define COUNTER_ASSOCIATIONS_REFUSED                24
#define COUNTER_ASSOCIATIONS_FAILED                 26

#define COUNTER_MESSAGES_IN_SEND_QUEUE              28
#define COUNTER_MESSAGES_IN_RECEIVE_QUEUE           30

// Counters for NDR's

#define COUNTER_NDRS_IN                             32
#define COUNTER_NDRS_OUT                            34

// Counters for Messages/Bytes Transferred

#define COUNTER_BYTES_TRANSFERRED_IN                36          // raid 40922
#define COUNTER_BYTES_TRANSFERRED_OUT               38          // raid 40922
#define COUNTER_TOTAL_EXCHANGE_DELIVERIES           40          // raid 40922
#define COUNTER_TOTAL_INTERNET_DELIVERIES           42

// Rate Counters

#define COUNTER_RATE_BYTES_TRANSFERRED_IN           44
#define COUNTER_RATE_BYTES_TRANSFERRED_OUT          46
#define COUNTER_RATE_EXCHANGE_DELIVERIES            48
#define COUNTER_RATE_INTERNET_DELIVERIES            50
#define COUNTER_RATE_CONNECTIONS_OUT                52
#define COUNTER_RATE_CONNECTIONS_IN                 54

// SNMP counters
#define COUNTER_MESSAGES_IN_SMTP_QUEUES             56
#define COUNTER_BYTES_IN_SMTP_QUEUES                58
#define COUNTER_TOTAL_RECIPIENTS_INBOUND            60
#define COUNTER_TOTAL_RECIPIENTS_OUTBOUND           62
#define COUNTER_TOTAL_RECIPIENTS_QUEUED             64
#define COUNTER_TOTAL_SUCCESSFUL_CONVERSIONS        66
#define COUNTER_TOTAL_FAILED_CONVERSIONS            68
#define COUNTER_TOTAL_LOOPS_DETECTED                70
#endif
