/* mtaperf.h   */
/* (C) COPYRIGHT DATA CONNECTION LIMITED 1993  */

/*****************************************************************************/
/* NT Performance Monitor integration for EMS : .H file for LODCTR.EXE       */
/*****************************************************************************/

/*****************************************************************************/
/* Object and counters for MTA (one instance)                                */
/*****************************************************************************/
#define MTA_OBJ             0
#define MTA_ASSOCS          2
#define MTA_MSGS            4
#define MTA_MSGBYTES        6
#define MTA_FREEELTS        8
#define MTA_FREEHDRS       10
#define MTA_MMICONNS       12
#define MTA_THREADS        14
#define MTA_WORKQ          16
#define MTA_GATEWAYS       18
#define MTA_CLIENTS        20
#define MTA_FILE_DELETES   22
#define MTA_FILE_SYNCS     24
#define MTA_FILE_OPENS     26
#define MTA_FILE_READS     28
#define MTA_FILE_WRITES    30
#define MTA_DS_READS       32
#define MTA_XAPI_RX_RATE   34
#define MTA_XAPI_TX_RATE   36
#define MTA_MMI_RX_RATE    38
#define MTA_MMI_TX_RATE    40
#define MTA_LAN_RX_RATE    42
#define MTA_LAN_TX_RATE    44
#define MTA_RAS_RX_RATE    46
#define MTA_RAS_TX_RATE    48
#define MTA_TCPIP_RX_RATE  50
#define MTA_TCPIP_TX_RATE  52
#define MTA_TP4_RX_RATE    54
#define MTA_TP4_TX_RATE    56
#define MTA_X25_RX_RATE    58
#define MTA_X25_TX_RATE    60
#define MTA_DEFERRED_MSGS  62

//---------------------------------------------------------------------------
// SNMP MADMAN MIB Support global counters
// (long counters are held last)
//---------------------------------------------------------------------------
                                                        // DWORD counters
#define MTA_STORED_MSGS                         MTA_WORKQ
#define MTA_STORED_RECIPS                       64
#define MTA_SUCCESSFUL_CONV_MSGS                66
#define MTA_FAILED_CONV_MSGS                    68
#define MTA_LOOPS_DETECTED                      70
                                                        // 64 bit counters
#define MTA_RECEIVED_MSGS                       72
#define MTA_TRANSMITTED_MSGS                    74
#define MTA_RECEIVED_VOLUME                     76
#define MTA_STORED_VOLUME                       78
#define MTA_TRANSMITTED_VOLUME                  80
#define MTA_RECEIVED_RECIPS                     82
#define MTA_TRANSMITTED_RECIPS                  84




/*****************************************************************************/
/* Object and Counters for each known entity (one instance per ECB)          */
/*****************************************************************************/
#define ENTITY_OBJ         86
#define ENTITY_ASSOCS      88
#define ENTITY_RCVBYTES    90
#define ENTITY_SNDBYTES    92
#define ENTITY_RCVMSGS     94
#define ENTITY_SNDMSGS     96
#define ENTITY_QSIZE       98

//---------------------------------------------------------------------------
// SNMP MADMAN MIB Support per entity counters
// (long counters are held last)
//---------------------------------------------------------------------------
                                                        // DWORD counters
#define ENTITY_STORED_MSGS                      ENTITY_QSIZE
#define ENTITY_INDEX                            100
#define ENTITY_REJECTED_MSGS                    102
#define ENTITY_STORED_RECIPS                    104
#define ENTITY_OLDEST_MSG_STORED                106
#define ENTITY_IN_ASSOCS                        108
#define ENTITY_OUT_ASSOCS                       110
#define ENTITY_ACCUM_IN_ASSOCS                  112
#define ENTITY_ACCUM_OUT_ASSOCS                 114
#define ENTITY_LAST_IN_ACTIVITY                 116
#define ENTITY_LAST_OUT_ACTIVITY                118
#define ENTITY_REJECTED_IN_ASSOCS               120
#define ENTITY_FAILED_OUT_ASSOCS                122
#define ENTITY_NEXT_RETRY                       124
#define ENTITY_IN_REJ_REASON                    126
#define ENTITY_OUT_FAIL_REASON                  128
                                                        //64 bit counters
#define ENTITY_RECEIVED_MSGS                    130
#define ENTITY_TRANSMITTED_MSGS                 132
#define ENTITY_RECEIVED_VOLUME                  134
#define ENTITY_STORED_VOLUME                    136
#define ENTITY_TRANSMITTED_VOLUME               138
#define ENTITY_RECEIVED_RECIPS                  140
#define ENTITY_TRANSMITTED_RECIPS               142



//---------------------------------------------------------------------------
// Markers for last counters for each object type
//---------------------------------------------------------------------------
#define MTA_SHORT_OBJ_END    MTA_LOOPS_DETECTED
#define MTA_SHORT_OBJ_NUM    (MTA_SHORT_OBJ_END - MTA_OBJ) / 2
#define MTA_LONG_OBJ_END    MTA_TRANSMITTED_RECIPS
#define MTA_LONG_OBJ_NUM    (MTA_LONG_OBJ_END - MTA_SHORT_OBJ_END) / 2

#define ENTITY_SHORT_OBJ_END ENTITY_OUT_FAIL_REASON
#define ENTITY_SHORT_OBJ_NUM (ENTITY_SHORT_OBJ_END - ENTITY_OBJ) / 2
#define ENTITY_LONG_OBJ_END ENTITY_TRANSMITTED_RECIPS
#define ENTITY_LONG_OBJ_NUM (ENTITY_LONG_OBJ_END - ENTITY_SHORT_OBJ_END) / 2

#define MTA_OBJ_NUM    (MTA_SHORT_OBJ_NUM + MTA_LONG_OBJ_NUM)
#define ENTITY_OBJ_NUM (ENTITY_SHORT_OBJ_NUM + ENTITY_LONG_OBJ_NUM)
