//-----------------------------------------------------------------------------
//
//  File: PERFIDX.H
//
//  Description:
//      Contains the complete list of PerfMon counter indexes for MSES.  These
//      indexes must start at zero and increase in multiples of two.  These
//      represent the object or counter name; the odd numbered counters (or
//      a given counter index plus 1) represents the counter help.
//
//  Author: johnhall
//
//  Copyright (C) 1996-1997 Microsoft Corporation
//
//-----------------------------------------------------------------------------

#ifndef _PERFIDX_H_
#define _PERFIDX_H_

// Main ES PerfMon Object

#define ES_OBJ                                      0

// Framework counters


#define ES_CNTR_NOTIFYRUNNING                       2 
#define ES_CNTR_NOTIFYQUEUE                         4
#define ES_CNTR_TOTALNOTIFYTIME                     6
#define ES_CNTR_LASTNOTIFYTIME0                     8
#define ES_CNTR_TOTALHANDLERTIM                    10
#define ES_CNTR_TOTALACTNSHNDLD                    12
#define ES_CNTR_HANDLRAVGPER100                    14
#define ES_CNTR_SCRIPTSEXECUTED                    16
#define ES_CNTR_TOTALSCRIPTTIME                    18
#define ES_CNTR_SCRIPTAVGPER100                    20
#define ES_CNTR_SCRIPTSTIMEDOUT                    22

// ES Connections PerfMon Object (Per-instance)

// #define ES_CONNS_OBJ                                24

// Per-connection counters


#endif  // _PERFIDX_H_
