/* ---------------------------------------------------------------------------- *\

    Description:
        Offset definition file for exensible counter objects and counters

        These "relative" offsets must start at 0 and be multiples of 2 (i.e.
        even numbers). In the Open Procedure, they will be added to the 
        "First Counter" and "First Help" values fo the device they belong to, 
        in order to determine the  absolute location of the counter and 
        object names and corresponding help text in the registry.

        This file is used by the extensible counter DLL code as well as the 
        counter name and help text definition file (.INI) file that is used
        by LODCTR to load the names into the registry.
        
        These are offsets from the "First Counter" value in the registry.

        Copyright 1986-1996 Microsoft Corporation. All Rights Reserved.

\*============================================================================*/
#if !defined( _MTPERF_H_ )
#define _MT_PERF_H 

// 
// indices for counters relative to the base defined by "First Counter"
//
#define OFFSET_OBJECT               0     
#define OFFSET_SFSEMS_TOTAL_MSGS    2       // # of messages from PC Mail to Exchange
#define OFFSET_SFSEMS_MSGS          4       // # of messages/hr from PC Mail to Exchange
#define OFFSET_SFSEMS_KB            6       // # of Kbytes/hr from PC Mail to Exchange /sec
#define OFFSET_EMSSFS_TOTAL_MSGS    8       // # of messages from Exchange from PC Mail
#define OFFSET_EMSSFS_MSGS          10      // # of messages/hr from Exchange from PC Mail
#define OFFSET_EMSSFS_KB            12      // # of Kbytes/hr from Exchange from PC Mail

#endif
