(* $Workfile:   dbserver.sch  $ $Revision:   2.20  $ *)
(* ------------------------------------------------------------------------- *)
(* SCHEMA DEFINITION TEST FILE                                               *)
(* ------------------------------------------------------------------------- *)

VERSION 1

(* ------------------------------------------------------------------------- *)
(* OBJECT CLASS 1 IS RESERVED FOR USE BY THE DB SERVER FOR QUEUES            *)
(*                           - CODE USES CONSTANT ODCQUECL                   *)
(* ------------------------------------------------------------------------- *)
OBJECT CLASS ID = 1
DIRECT COPY LIM = 0

(* ATTR | Single | Indexed | Reserved | Masking | Comment                    *)
(*  ID  | Multi  |   Y/N   |   Size   |   op    |                            *)
(*   ________         __________                                             *)
(*   | TYPE |         | INIT ? |                                             *)
(*   |      |         |        |                                             *)

    2   UP  S         N   N      0        NA       QUEUE NAME
    3   UP  S         N   N      0        NA       QUEUE ORDERING ATTRIBUTE ID
    4   UP  S         N   N      0        NA       QUEUE ORDERING MASK
    5   UP  S         N   N      0        NA       QUEUE SIZE - NO OF ENTRIES
    6   UP  S         N   N      0        NA       QUEUE WASTE - NO OF DELS
    7   UP  H         N   N      0        NA       QUEUE ENTRIES LIST
    8   UP  S         N   N      0        NA       QUEUE HEAD INDEX

END OF OBJECT CLASS


(* ------------------------------------------------------------------------- *)
(* OBJECT CLASS 2 IS RESERVED FOR USE BY THE DB SERVER FOR THE               *)
(*   QUEUE-DESCRIPTOR OBJECT - CODE USES CONSTANT ODCQDOCL                   *)
(* ------------------------------------------------------------------------- *)
OBJECT CLASS ID = 2
DIRECT COPY LIM = 0

(* ATTR | Single | Indexed | Reserved | Masking | Comment                    *)
(*  ID  | Multi  |   Y/N   |   Size   |   op    |                            *)
(*   ________         __________                                             *)
(*   | TYPE |         | INIT ? |                                             *)
(*   |      |         |        |                                             *)

    2   UP  H         N   N      0        NA       LIST OF NAMES/OBJ IDS
    3   UP  M         N   N      0        NA       LIST OF REMOTE SERVERS

END OF OBJECT CLASS




(* ------------------------------------------------------------------------- *)
OBJECT CLASS ID = 3
DIRECT COPY LIM = 100

(* ATTR | Single | Indexed | Reserved | Masking | Comment                    *)
(*  ID  | Multi  |   Y/N   |   Size   |   op    |                            *)
(*   ________         __________                                             *)
(*   | TYPE |         | INIT ? |                                             *)
(*   |      |         |        |                                             *)

    4   UP  S         N   N      0        NA
    5   UP  H         N   N      0        NA

END OF OBJECT CLASS


(* ------------------------------------------------------------------------- *)
(* OBJECT CLASS 4 IS RESERVED FOR USE BY THE DB SERVER FOR THE               *)
(*   QUEUE-DESCRIPTOR OBJECT - CODE USES CONSTANT ODCQDOCL                   *)
(* ------------------------------------------------------------------------- *)
OBJECT CLASS ID = 4
DIRECT COPY LIM = 20

(* ATTR | Single | Indexed | Reserved | Masking | Comment                    *)
(*  ID  | Multi  |   Y/N   |   Size   |   op    |                            *)
(*   ________         __________                                             *)
(*   | TYPE |         | INIT ? |                                             *)
(*   |      |         |        |                                             *)

    3   R   S         N   Y      0        GT
    4   RW  S         N   Y      0        LE
    5   RW  S         N   Y      0        LE
    2   RW  S         Y   Y      0        EQ
    6   RW  M         N   N      0        SU
    7   RW  M         N   N      0        PR
    8   RW  S         N   Y      0        SU
    23  RW  M         N   N      0        NA

END OF OBJECT CLASS


(* ------------------------------------------------------------------------- *)
(* OBJECT CLASS 5 IS SET UP FOR TIMER MEASUREMENTS                           *)
(* ------------------------------------------------------------------------- *)
OBJECT CLASS ID = 5
DIRECT COPY LIM = 50

(* ATTR | Single | Indexed | Reserved | Masking | Comment                    *)
(*  ID  | Multi  |   Y/N   |   Size   |   op    |                            *)
(*   ________         __________                                             *)
(*   | TYPE |         | INIT ? |                                             *)
(*   |      |         |        |                                             *)

    2   UP  S         N   N      0        NA
    3   UP  S         N   N      0        NA
    4   UP  S         N   N      0        NA
    5   UP  S         N   N      0        NA
    6   UP  S         N   N      0        NA
    7   UP  S         N   N      0        NA
    8   UP  S         N   N      0        NA
    9   UP  S         N   N      0        NA
    10  UP  S         N   N      0        NA
    11  UP  S         N   N      0        NA
    12  UP  S         N   N      0        NA
    13  UP  S         N   N      0        NA
    14  UP  S         N   N      0        NA
    15  UP  S         N   N      0        NA
    16  UP  S         N   N      0        NA
    17  UP  S         N   N      0        NA
    18  UP  S         N   N      0        NA
    19  UP  S         N   N      0        NA
    20  UP  S         N   N      0        NA
    21  UP  S         N   N      0        NA
    22  UP  S         N   N      0        NA
    23  UP  M         N   N      0        NA
    24  UP  M         N   N      0        NA

END OF OBJECT CLASS


(* ------------------------------------------------------------------------- *)
(* OBJECT CLASS 6 IS SET UP FOR THE GREAT AND GLORIOUS POP-MTA (RA, RA, RA)  *)
(* ------------------------------------------------------------------------- *)
OBJECT CLASS ID = 6
DIRECT COPY LIM = 14

(* ATTR | Single | Indexed | Reserved | Masking | Comment                    *)
(*  ID  | Multi  |   Y/N   |   Size   |   op    |                            *)
(*   ________         __________                                             *)
(*   | TYPE |         | INIT ? |                                             *)
(*   |      |         |        |                                             *)

(* ATTRIBUTE 2 IS AN INTERFACE-DEFINED ATTRIBUTE CONTAINING THE ACTUAL APDU  *)
    2   R   M         N   Y      0        NA       THE ACTUAL APDU

    4   RW  S         N   Y      0        NA       THE RESPONSIBLE PRODUCT NAME
    5   UP  S         N   Y      0        NA       INTERNAL PER_MESSAGE FLAGS
    6   UP  S         N   Y      0        NA       SOURCE OBJECT NAME IN COPIES
    7   UP  M         N   N      0        NA       SCRATCH ATTRIB FOR FEEDER Q

    9   RW  S         N   N      0        NA       MTS-IDENTIFIER
    10  RW  S         N   Y      0        NA       INVOKE ID
    11  R   M         N   N      0        NA       MESSAGE CONTENT
    12  R   S         N   Y      0        NA       CONTENT IDENTIFIER
    13  RW  M         N   N      0        NA       CONTENT TYPE
    14  RW  S         N   Y      0        NA       CONTENT LENGTH
    15  RW  M         N   N      0        NA       ORIGINAL ENCODED INFO TYPES
    16  RW  M         N   N      0        NA       CURRENT ENCODED INFO TYPES
    17  R   M         N   N      0        NA       REPORTED ON RECIPIENT DNs
    18  R   M         N   Y      0        NA       THE ACTUAL APDU
    19  RW  S         N   Y      0        NA       RESPONSIBILITY        BITMAP
    20  RW  S         N   Y      0        NA       DELIVERY REPORT REQD  BITMAP
    21  RW  S         N   Y      0        NA       NONDELIVERY RPT REQD  BITMAP
    22  RW  S         N   Y      0        NA       ROUTING ACTION        BITMAP
    23  RW  S         N   Y      0        NA       ORIG-RQD-ALT-RCP      BITMAP
    24  RW  S         N   Y      0        NA       REPORT DELIVERY       BITMAP
    25  UP  M         N   N      0        NA       ORIGINATOR
    
    27  RW  S         N   Y      0        NA       PER MESSAGE INDICATORS
    28  UP  M         N   N      0        NA       SEQUENCE OF RECIPIENT INFO
    29  UP  M         N   N      0        NA       SEQUENCE OF RPT RCPIENT INFO
    30  RW  M         N   N      0        NA       PER MSG PRIVATE EXTENSION
    31  RW  M         N   N      0        NA       REPORT CONT PRIVATE EXTENSION
    32  R   S         N   Y      0        NA       ORIGINATOR CERTIFICATE
    33  R   S         N   Y      0        NA       CONTENT CONFIDENT ALG ID
    34  R   S         N   Y      0        NA       ORIGIN-AUTHENTICATION CHECK
    35  R   S         N   Y      0        NA       MESSAGE SECURITY LABEL
    36  R   S         N   Y      0        NA       CONTENT CORRELATOR
    
    39  R   S         N   Y      0        NA       SUBMISSION          TIME
    40  R   S         N   Y      0        NA       DELIVERY            TIME
    41  RW  S         N   Y      0        NA       ARRIVAL             TIME
    42  R   S         N   Y      0        NA       LATEST DELIVERY     TIME - C
    43  R   S         N   Y      0        NA       DEFERRED DELIVERY   TIME
    44  RW  M         N   N      0        NA       THIS RECIPIENT      NAME
    45  RW  M         N   N      0        NA       OTHER RECIPIENT     NAME
    46  RW  M         N   N      0        NA       INTENDED RECIPIENT  NAME
    47  RW  M         N   N      0        NA       DELIVERY RPT PER RECIP INFO
    48  RW  M         N   N      0        NA       CONVERTED ENCODED INFO TYPES
    49  RW  M         N   N      0        NA       1984 PER-RECIP INFO (RPT TOO)
    50  RW  M         N   N      0        NA       1984 EXTERNAL TRACE INFO
    51  RW  M         N   N      0        NA       PER DOMAIN INFORMATION
    52  UP  M         N   N      0        NA       INTENTIONS LIST
    53  RW  S         N   Y      0        NA       OBJECT SENT - ID OF ASB CB
    54  RW  M         N   N      0        NA       NUMBER OF RECIPIENTS

    56  RW  M         N   N      0        NA       REROUTE LIST
    57  RW  M         N   N      0        NA       1984 SUBJECT TRACE INFO
    58  RW  M         N   N      0        NA       MULTI RECIP, SEQ OF RCP INFO
    59  RW  M         N   N      0        NA       EXTENSIONS
    60  R   S         N   Y      0        NA       ORIGINATOR RETURN ADDRESS
    61  R   S         N   Y      0        NA       CONV W/O LOSS EXTN IN ASN.1
    62  RW  M         N   Y      0        NA       1984 PER-DOMAIN INFORMATION
    63  R   M         N   N      0        NA       1984 EXTERNAL MESSAGE CONTENT
    64  RW  M         N   N      0        NA       SUBJECT INTERMEDIATE TRACE
    65  R   S         N   Y      0        NA       ADDITIONAL TRACE INFO
    66  R   S         N   Y      0        NA       REPORT SUBJECT IDENTIFIER
    67  R   S         N   Y      0        NA       LATEST DELIVERY       TIME
    68  R   S         N   Y      0        NA       RECEIPT REASSIGNMENT PROHIB
    69  RW  S         N   N      0        NA       TRACE INFORMATION DATA
    70  RW  M         N   N      0        NA       1984-SAFE INTERNAL TRACE INFO
    71  RW  M         N   N      0        NA       OUTPUT OWN TRACE INFO ELT
    72  RW  M         N   N      0        NA       OUTPUT INTERNAL TRACE ELT
    73  RW  M         N   N      0        NA       SENDER O/R NAME
    74  RW  M         N   Y      0        NA       DL EXPANSION HISTORY EXTN
    75  UP  M         N   N      0        NA       DL EXPN HISTORY ASN.1 NO IL
    76  R   S         N   Y      0        NA       DL EXPANSION PROHIBITED EXTN

    78  R   S         N   Y      0        NA       REPORTING DL NAME EXTN
    79  RW  M         N   Y      0        NA       ORIG&DL EXP HISTORY EXTN
    80  UP  S         N   Y      0        NA       DATA OBJECT?
    81  RW  M         N   N      0        NA       ORIG&DL-EXP-HIST ASN.1 NO IL
    82  UP  M         N   N      0        NA       SCRATCH ATTRIB FOR DEGRADE
    83  RW  S         N   Y      0        NA       DEGRADE BITMAP
    84  RW  M         N   N      0        NA       REDIRECTION HISTORY
    85  R   S         N   Y      0        NA       REPORT/ORIG-MTA-CERT EXTN
    86  RW  S         N   Y      0        NA       RESPONSIBLE RCPT COUNT

    88  R   S         N   Y      0        NA       PROOF-OF-SUBMISSION EXTN
    89  R   M         N   N      0        NA       POP-PLATFORM SCRATCH ATTR
    90  RW  S         N   Y      0        NA       XAPI OM OBJECT CLASS

    92  R   S         N   Y      0        NA       OBJECT USAGE COUNT
    93  RW  S         N   Y      0        NA       QUEUE TIME FOR OBJECT
    94  R   M         N   N      0        NA       ODATHISD
    95  R   M         N   N      0        NA       OLD MESSAGE CONTENT
    96  R   M         N   N      0        NA       CONVERSION SCRATCH AREA
    97  RW  S         N   Y      0        NA       COPY OF RSP BM FOR DVL RSLTS
    98  UP  M         N   N      0        NA       DOORWAY LIST (RE-ROUTE)
    99  UP  M         N   N      0        NA       TARGET MTA/MD LIST (REROUTE)

END OF OBJECT CLASS

(* ------------------------------------------------------------------------- *)
(* OBJECT CLASS 7 IS SET UP FOR POP-MTA TO USE FOR LIST OF ENTITY QUEUES     *)
(* ------------------------------------------------------------------------- *)
OBJECT CLASS ID = 7
DIRECT COPY LIM = 100

(* ATTR | Single | Indexed | Reserved | Masking | Comment                    *)
(*  ID  | Multi  |   Y/N   |   Size   |   op    |                            *)
(*   ________         __________                                             *)
(*   | TYPE |         | INIT ? |                                             *)
(*   |      |         |        |                                             *)

    2   UP  M         N   N      0        NA       ENTITY QUEUE LIST

END OF OBJECT CLASS

(* ------------------------------------------------------------------------- *)
(* OBJECT CLASS 8 IS SET UP FOR MT-BASE FEEDER QUEUE USAGE                   *)
(* ------------------------------------------------------------------------- *)
OBJECT CLASS ID = 8
DIRECT COPY LIM = 100

(* ATTR | Single | Indexed | Reserved | Masking | Comment                    *)
(*  ID  | Multi  |   Y/N   |   Size   |   op    |                            *)
(*   ________         __________                                             *)
(*   | TYPE |         | INIT ? |                                             *)
(*   |      |         |        |                                             *)

(* Attribute 82 is the attribute that contains the control message data for  *)
(* the feeder queue object.  This object class is only used if the adding    *)
(* thread does not have an object it can use for the purpose.                *)
    82  UP  M         N   N      0        NA       SCRATCH ATTRIB

END OF OBJECT CLASS

(* ------------------------------------------------------------------------- *)
(* OBJECT CLASS 9 IS SET UP HANDLING OF P2 MESSAGES                          *)
(* ------------------------------------------------------------------------- *)
OBJECT CLASS ID = 9
DIRECT COPY LIM = 100

(* ATTR | Single | Indexed | Reserved | Masking | Comment                    *)
(*  ID  | Multi  |   Y/N   |   Size   |   op    |                            *)
(*   ________         __________                                             *)
(*   | TYPE |         | INIT ? |                                             *)
(*   |      |         |        |                                             *)

(* ATTRIBUTE 2 IS AN INTERFACE-DEFINED ATTRIBUTE CONTAINING THE P1/P3 CONTENT*)
    2   R   M         N   N      0        NA       P2 CONTENT - WITH IL

    4   RW  S         N   Y      0        NA       QUEUE ID


    5    R  S         N   Y      0        NA       TYPE OF MESSAGE - INTEGER
(*                                                   1 => P2 MESSAGE
(*                                                   2 => P2 +ve NOTIFICATION
(*                                                   3 => P2 -ve NOTIFICATION
    6    R  S         N   Y      0        NA       IPM/IPN ORIGINATOR - NO IL
    7   UP  S         N   Y      0        NA       SUBJECT
    8    R  M         N   N      0        NA       PRIMARY RECIPIENTS
(*                                                   RECIPIENT SPECIFIERS NO IL
    9    R  M         N   N      0        NA       COPY RECIPIENTS
(*                                                   RECIPIENT SPECIFIERS NO IL
    10   R  M         N   N      0        NA       BLIND COPY RECIPIENTS
(*                                                   RECIPIENT SPECIFIERS NO IL
    11   R  M         N   N      0        NA       REPLY RECIPIENTS
(*                                                   O/R DESCRIPTORS - NO IL
    12   R  M         N   N      0        NA       BODY PARTS WITH IL
    13   R  M         N   N      0        NA       FORWARDED MESSAGES
(*                                                   LIST OF OBJECT IDs
    14   R  S         N   Y      0        NA       IMPORTANCE
(*                                                   LOW(0), NORMAL(1), HIGH(2)
    15   R  S         N   Y      0        NA       SENSITIVITY
    16   R  S         N   Y      0        NA       THIS IPM - NO IL
    17   R  S         N   Y      0        NA       REPLY TIME
    18   R  M         N   N      0        NA       AUTHORISING USERS
(*                                                   O/R DESCRIPTORS NO IL
    19   R  S         N   Y      0        NA       AUTO-FORWARDED BOOLEAN
    20   R  S         N   Y      0        NA       EXPIRY TIME
    21   R  M         N   N      0        NA       OBSOLETED IPMs
(*                                                   IPM IDs NO IL
    22   R  M         N   N      0        NA       RELATED IPMs
(*                                                   IPM IDs NO IL
    23   R  S         N   Y      0        NA       REPLIED TO IPM NO IL
    24   R  S         N   Y      0        NA       CONVERTED EITs
    25   R  S         N   Y      0        NA       IPM INTENDED RECIPIENT
(*                                                   O/R DESCRIPTOR - NO IL
    26   R  S         N   Y      0        NA       SUBJECT IPM - NO IL
    27   R  S         N   Y      0        NA       AUTO-FORWARD COMMENT
    28   R  S         N   Y      0        NA       DISCARD REASON
    29   R  S         N   Y      0        NA       NON-RECEIPT REASON
    30  UP  S         N   Y      0        NA       RETURNED IPM - NO IL
    31   R  S         N   Y      0        NA       ACKNOWLEDGEMENT MODE
    32   R  S         N   Y      0        NA       RECEIPT TIME
    33   R  S         N   Y      0        NA       SUPPLEMENTARY RECEIPT INFO
    34   R  M         N   N      0        NA       BODY PARTS - ASN.1 SE_ OF
(*                                                   USED DURING P2 ENCODE
    35   R  M         N   N      0        NA       LANGUAGES - STRING NO IL
    36   R  S         N   Y      0        NA       INCOMPLETE COPY - BOOLEAN

(* FORWARDED MESSAGES   - SAME FORMAT AS MTA                             *)
(* ~~~~~~~~~~~~~~~~~~                                                    *)
    40   R  S         N   Y      0        NA       CONTENT TYPE
    41   R  S         N   Y      0        NA       ORIGINATOR NAME
    42   R  M         N   N      0        NA       ORIG-ENCODED-INFO-TYPE
    43   R  S         N   Y      0        NA       PRIORITY
    44   R  M         N   N      0        NA       DELIVERY FLAGS
    45   R  M         N   N      0        NA       OTHER RECIPIENT NAMES
    46   R  M         N   N      0        NA       THIS RECIPIENT NAME
    47   R  M         N   N      0        NA       ORIGINAL-INTENDED-RECIP-NM
    48   R  M         N   N      0        NA       CONVERTED-ENCODE-INFO-TYPES
    49   R  S         N   Y      0        NA       MESSAGE SUBMISSION TIME
    50   R  S         N   Y      0        NA       CONTENT ID
    51   R  M         N   N      0        NA       EXTENSIONS
    52   R  M         N   N      0        NA       MULTI RECIP, SEQ OF RCP INFO
    53   R  S         N   Y      0        NA       DELIVERY TIME
    54   R  M         N   N      0        NA       THIS RECIPIENT NAME (STRDN)
    55   R  S         N   Y      0        NA       CONTENT LENGTH

    56   R  M         N   N      0        NA       RN-REQUESTORS
    57   R  M         N   N      0        NA       NRN-REQUESTORS
    58   R  M         N   N      0        NA       REPLY-REQUESTORS

    60   R  S         N   Y      0        NA       OBJECT STATUS - BITSRING
(*                                                    BIT 0 = 1 => P2 DECODED
(*                                                    BIT 1 = 1 => APDU VALID

(* ATTRIBUTE USAGE SPECIFIC TO POP-MS IS INDICATED BY "MS:"
    65  R   M         N   N      0        NA       BODY PARTS
(*                                                 MS: BODY PART DATA
    66  R   M         N   N      0        NA       BODY PARTS
(*                                                 MS: BODY PART PARAMETERS
    67  R   M         N   N      0        NA       BODY PARTS
(*                                                 MS: CONTENT CONFID ALG
    68  R   M         N   N      0        NA       BODY PARTS
(*                                                 MS: CONTENT CORRELATOR
    69  R   M         N   N      0        NA       BODY PARTS
(*                                                 MS: CONVERTED EITS
    70  R   M         N   N      0        NA       BODY PARTS
(*                                                 MS: CONTENT INTEGRITY CHECK
    71  R   M         N   N      0        NA       BODY PARTS
(*                                                 MS: CONTENT TYPE
    72  R   M         N   N      0        NA       BODY PARTS
(*                                                 MS: CONV WITH LOSS PROHIBIT
    73  R   M         N   N      0        NA       BODY PARTS
(*                                                 MS: DL EXPN HISTORY
    74  R   M         N   N      0        NA       BODY PARTS
(*                                                 MS: MTS DELIVERY ID
    75  R   M         N   N      0        NA       BODY PARTS
(*                                                 MS: MSG ORIG AUTHENT CHECK
    76  R   M         N   N      0        NA       BODY PARTS
(*                                                 MS: MSG SECURITY LABEL
    77   R  M         N   N      0        NA       MS: MESSAGE TOKEN
    78   R  M         N   N      0        NA       MS: ORIGINAL EITS (OIDS)
    79   R  S         N   Y      0        NA       MS: ORIGINATOR CERTIFICATE
    80   R  M         N   N      0        NA       MS: PER-RECIP RPT DLV FIELDS
    81   R  M         N   N      0        NA       MS: PROOF OF DELIVRY REQUEST
    82  UP  M         N   N      0        NA       SCRATCH ATTRIB FOR XAPI
(*                                                 MS: REDIRECTION HISTORY
    83   R  S         N   Y      0        NA       MS: REPORTING DL NAME
    84   R  S         N   Y      0        NA       MS: REPORTING MTA CERTIFIC
    85   R  S         N   Y      0        NA       MS: RPT ORIG AUTHENTIC CHECK
    86   R  M         N   N      0        NA       MS: SECURITY CLASSIFICATION
    87   R  S         N   Y      0        NA       MS: SEQUENCE NUMBER
    88   R  S         N   Y      0        NA       MS: SUBJECT SUBMISSION ID
    89   R  M         N   N      0        NA       MS: EXT DEFD BODY PART TYPES
    90  RW  S         N   Y      0        NA       XAPI OM OBJECT CLASS
(*                                                 MS: IPM HEADING (-IL)
    91   R  S         N   Y      0        NA       MS: IPM BODY (-IL)
    92   R  S         N   Y      0        NA       OBJECT USAGE COUNT
(*                                                 MS: NRN FLAG
    93   R  S         N   Y      0        NA       MS: CONVERSION EITS

END OF OBJECT CLASS

(* ------------------------------------------------------------------------- *)
(* OBJECT CLASS 10 IS SET UP FOR POP-XAPI AND HOLDS A LIST OF THE CURRENTLY  *)
(* CONFIGURED SECURE QUEUE NAMES.  ALSO HOLDS HEAP STRING SPACE FOR XAPI     *)
(* CLIENT SESSIONS WHO LEAVE THEIR LONGSTRINGS ON THE SERVER                 *)
(* ------------------------------------------------------------------------- *)
OBJECT CLASS ID = 10
DIRECT COPY LIM = 100

(* ATTR | Single | Indexed | Reserved | Masking | Comment                    *)
(*  ID  | Multi  |   Y/N   |   Size   |   op    |                            *)
(*   ________         __________                                             *)
(*   | TYPE |         | INIT ? |                                             *)
(*   |      |         |        |                                             *)

    4   UP  S         N   Y      0        NA       THE RESPONSIBLE PRODUCT NAME
    5   UP  M         N   N      0        NA       SECURE QUEUE LIST 1
    6   UP  M         N   N      0        NA       SECURE QUEUE LIST 2
    7   UP  S         N   Y      0        NA       WHICH QUEUE LIST TO USE

    97  UP  H         N   N      0        NA       DIRECT STRING HEAP SPACE

END OF OBJECT CLASS

(* ------------------------------------------------------------------------- *)
(* OBJECT CLASS 11 IS SET UP FOR POP-XAPI TO USE AS A P1/P3 WORK OBJECT AND  *)
(* IS IDENTICAL TO CLASS 6 BUT WITH ALL ATTRIBUTES MULTI-VALUED              *)
(* ------------------------------------------------------------------------- *)

OBJECT CLASS ID = 11
DIRECT COPY LIM = 40

(* ATTR | Single | Indexed | Reserved | Masking | Comment                    *)
(*  ID  | Multi  |   Y/N   |   Size   |   op    |                            *)
(*   ________         __________                                             *)
(*   | TYPE |         | INIT ? |                                             *)
(*   |      |         |        |                                             *)

(* ATTRIBUTE 2 IS AN INTERFACE-DEFINED ATTRIBUTE CONTAINING THE ACTUAL APDU  *)
    2   UP  M         N   Y      0        NA       THE ACTUAL APDU

    4   RW  S         N   Y      0        NA       THE RESPONSIBLE PRODUCT NAME
    5   UP  M         N   N      0        NA       INTERNAL PER_MESSAGE FLAGS
    6   UP  M         N   N      0        NA       SOURCE OBJECT NAME IN COPIES
    7   UP  M         N   N      0        NA       OBJECT SOURCE
    8   RW  M         N   N      0        NA       TYPE OF MESSAGE
    9   RW  M         N   N      0        NA       MTS-IDENTIFIER
    10  RW  M         N   N      0        NA       INVOKE ID
    11  RW  M         N   N      0        NA       MESSAGE CONTENT
    12  R   M         N   N      0        NA       CONTENT IDENTIFIER
    13  RW  M         N   N      0        NA       CONTENT TYPE
    14  RW  M         N   N      0        NA       CONTENT LENGTH
    15  RW  M         N   N      0        NA       ORIGINAL ENCODED INFO TYPES
    16  RW  M         N   N      0        NA       CURRENT ENCODED INFO TYPES

    18  RW  M         N   N      0        NA       SOURCE RESPONSIBILITY BITMAP
    19  RW  M         N   N      0        NA       RESPONSIBILITY        BITMAP
    20  RW  M         N   N      0        NA       DELIVERY REPORT REQD  BITMAP
    21  RW  M         N   N      0        NA       NONDELIVERY RPT REQD  BITMAP
    22  RW  M         N   N      0        NA       ROUTING ACTION        BITMAP
    23  RW  M         N   N      0        NA       ORIG-RQD-ALT-RCP      BITMAP
    24  RW  M         N   N      0        NA       REPORT DELIVERY       BITMAP
    25  R   M         N   N      0        NA       ORIGINATOR
   
    27  RW  M         N   N      0        NA       PER MESSAGE INDICATORS
    28  UP  M         N   N      0        NA       SEQUENCE OF RECIPIENT INFO
    29  UP  M         N   N      0        NA       SEQUENCE OF RPT RCPIENT INFO
    30  R   M         N   N      0        NA       RECIP REASSIGNMENT PROHIB- C
    31  R   M         N   N      0        NA       CONVERS-WITH-LOSS PROHIB - C
    32  R   M         N   N      0        NA       ORIGINATOR CERTIFICATE
    33  R   M         N   N      0        NA       CONTENT CONFIDENT ALG ID
    34  R   M         N   N      0        NA       ORIGIN-AUTHENTICATION CHECK
    35  R   M         N   N      0        NA       MESSAGE SECURITY LABEL
    36  R   M         N   N      0        NA       CONTENT CORRELATOR
    
    39  R   M         N   N      0        NA       SUBMISSION          TIME
    40  R   M         N   N      0        NA       DELIVERY            TIME
    41  RW  M         N   N      0        NA       ARRIVAL             TIME
    42  R   M         N   N      0        NA       LATEST DELIVERY     TIME - C
    43  R   M         N   N      0        NA       DEFERRED DELIVERY   TIME
    44  R   M         N   N      0        NA       THIS RECIPIENT      NAME
    45  RW  M         N   N      0        NA       OTHER RECIPIENT     NAME
    46  R   M         N   N      0        NA       INTENDED RECIPIENT  NAME
    47  R   M         N   N      0        NA       DELIVERY RPT PER RECIP INFO
    48  RW  M         N   N      0        NA       CONVERTED ENCODED INFO TYPES
    49  RW  M         N   N      0        NA       1984 PER-RECIP INFO (RPT TOO)
    50  RW  M         N   N      0        NA       1984 EXTERNAL TRACE INFO
    51  RW  M         N   N      0        NA       PER DOMAIN INFORMATION
    52  UP  M         N   N      0        NA       INTENTIONS LIST
    53  RW  M         N   N      0        NA       OBJECT SENT - ID OF ASB CB
    54  RW  M         N   N      0        NA       NUMBER OF RECIPIENTS
    55  RW  M         N   N      0        NA       HELD QUEUE WITH THIS OBJECT
    56  RW  M         N   N      0        NA       REROUTE LIST

    58  RW  M         N   N      0        NA       MULTI RECIP, SEQ OF RCP INFO
    59  R   M         N   N      0        NA       EXTENSIONS
    60  R   M         N   N      0        NA       ORIGINATOR RETURN ADDRESS
    61  R   M         N   N      0        NA       CONV W/O LOSS EXTN IN ASN.1
    62  RW  M         N   N      0        NA       1984 PER-DOMAIN INFORMATION
    63  RW  M         N   N      0        NA       1984 EXTERNAL MESSAGE CONTENT
    64  R   M         N   N      0        NA       SUBJECT INTERMEDIATE TRACE
    65  R   M         N   N      0        NA       ADDITIONAL TRACE INFO
    66  R   M         N   N      0        NA       REPORT SUBJECT IDENTIFIER
    67  R   M         N   N      0        NA       LATEST DELIVERY       TIME
    68  R   M         N   N      0        NA       RECEIPT REASSIGNMENT PROHIB
    69  RW  M         N   N      0        NA       NUMBER OF INTERMEDIATE TRACE
    70  RW  M         N   N      0        NA       1984-SAFE INTERNAL TRACE INFO
    71  RW  M         N   N      0        NA       OUTPUT OWN TRACE INFO ELT
    72  RW  M         N   N      0        NA       OUTPUT INTERNAL TRACE ELT
    73  RW  M         N   N      0        NA       SENDER O/R NAME
    74  RW  M         N   N      0        NA       DL EXPANSION HISTORY EXTN
    75  UP  M         N   N      0        NA       DL EXPN HISTORY ASN.1 NO IL
    76  R   M         N   N      0        NA       DL EXPANSION PROHIBITED EXTN
    77  R   M         N   N      0        NA       DL EXPN PROHIBITED BOOLEAN
    78  R   M         N   N      0        NA       REPORTING DL NAME EXTN
    79  RW  M         N   N      0        NA       ORIG&DL EXP HISTORY EXTN

    81  RW  M         N   N      0        NA       ORIG&DL-EXP-HIST ASN.1 NO IL
    82  UP  M         N   N      0        NA       SCRATCH ATTRIB FOR DEGRADE
    83  RW  M         N   N      0        NA       DEGRADE BITMAP
    84  RW  M         N   N      0        NA       REDIRECTION HISTORY
    85  R   M         N   N      0        NA       REPORT/ORIG-MTA-CERT EXTN

    87  R   M         N   N      0        NA       PROOF-OF-SUBMSSN-REQD - C
    88  R   M         N   N      0        NA       PROOF-OF-SUBMISSION EXTN
    89  RW  M         N   N      0        NA       ASSOCIATED P2 OBJECT
    90  RW  S         N   Y      0        NA       XAPI OM OBJECT CLASS

    92  R   S         N   Y      0        NA       OBJECT USAGE COUNT

END OF OBJECT CLASS

(* ------------------------------------------------------------------------- *)
(* OBJECT CLASS 12 IS SET UP FOR POP-XAPI TO USE AS A P2 WORK OBJECT AND     *)
(* IS IDENTICAL TO CLASS 9 BUT WITH ALL ATTRIBUTES MULTI-VALUED              *)
(* ------------------------------------------------------------------------- *)

OBJECT CLASS ID = 12
DIRECT COPY LIM = 100

(* ATTR | Single | Indexed | Reserved | Masking | Comment                    *)
(*  ID  | Multi  |   Y/N   |   Size   |   op    |                            *)
(*   ________         __________                                             *)
(*   | TYPE |         | INIT ? |                                             *)
(*   |      |         |        |                                             *)

(* ATTRIBUTE 2 IS AN INTERFACE-DEFINED ATTRIBUTE CONTAINING THE P1/P3 CONTENT*)
    2   R   M         N   N      0        NA       P2 CONTENT - WITH IL

    4   RW  S         N   N      0        NA       QUEUE ID

    5    R  M         N   N      0        NA       TYPE OF MESSAGE - INTEGER
(*                                                   1 => P2 MESSAGE
(*                                                   2 => P2 +ve NOTIFICATION
(*                                                   3 => P2 -ve NOTIFICATION
    6    R  M         N   N      0        NA       IPM/IPN ORIGINATOR - NO IL
    7    R  M         N   N      0        NA       SUBJECT
    8    R  M         N   N      0        NA       PRIMARY RECIPIENTS
(*                                                   RECIPIENT SPECIFIERS NO IL
    9    R  M         N   N      0        NA       COPY RECIPIENTS
(*                                                   RECIPIENT SPECIFIERS NO IL
    10   R  M         N   N      0        NA       BLIND COPY RECIPIENTS
(*                                                   RECIPIENT SPECIFIERS NO IL
    11   R  M         N   N      0        NA       REPLY RECIPIENTS
(*                                                   O/R DESCRIPTORS - NO IL
    12   R  M         N   N      0        NA       BODY PARTS WITH IL
    13   R  M         N   N      0        NA       FORWARDED MESSAGES
(*                                                   LIST OF OBJECT IDs
    14   R  M         N   N      0        NA       IMPORTANCE
(*                                                   LOW(0), NORMAL(1), HIGH(2)
    15   R  M         N   N      0        NA       SENSITIVITY
    16   R  M         N   N      0        NA       THIS IPM - NO IL
    17   R  M         N   N      0        NA       REPLY TIME
    18   R  M         N   N      0        NA       AUTHORISING USERS
(*                                                   O/R DESCRIPTORS NO IL
    19   R  M         N   N      0        NA       AUTO-FORWARDED BOOLEAN
    20   R  M         N   N      0        NA       EXPIRY TIME
    21   R  M         N   N      0        NA       OBSOLETED IPMs
(*                                                   IPM IDs NO IL
    22   R  M         N   N      0        NA       RELATED IPMs
(*                                                   IPM IDs NO IL
    23   R  M         N   N      0        NA       REPLIED TO IPM NO IL
    24   R  M         N   N      0        NA       CONVERTED EITs
    25   R  M         N   N      0        NA       IPM INTENDED RECIPIENT
(*                                                   O/R DESCRIPTOR - NO IL
    26   R  M         N   N      0        NA       SUBJECT IPM - NO IL
    27   R  M         N   N      0        NA       AUTO-FORWARD COMMENT
    28   R  M         N   N      0        NA       DISCARD REASON
    29   R  M         N   N      0        NA       NON-RECEIPT REASON
    30  UP  M         N   N      0        NA       RETURNED IPM - NO IL
    31   R  M         N   N      0        NA       ACKNOWLEDGEMENT MODE
    32   R  M         N   N      0        NA       RECEIPT TIME
    33   R  M         N   N      0        NA       SUPPLEMENTARY RECEIPT INFO
    34  UP  M         N   N      0        NA       BODY PARTS - ASN.1 SE_ OF
    35   R  M         N   N      0        NA       LANGUAGES - STRING NO IL
    36   R  M         N   N      0        NA       INCOMPLETE COPY - BOOLEAN

(* FORWARDED MESSAGES   - SAME FORMAT AS MTA                             *)
(* ~~~~~~~~~~~~~~~~~~                                                    *)
    40   R  M         N   N      0        NA       CONTENT TYPE
    41   R  M         N   N      0        NA       ORIGINATOR NAME
    42   R  M         N   N      0        NA       ORIG-ENCODED-INFO-TYPE
    43   R  M         N   N      0        NA       PRIORITY
    44   R  M         N   N      0        NA       DELIVERY FLAGS
    45   R  M         N   N      0        NA       OTHER RECIPIENT NAMES
    46   R  M         N   N      0        NA       THIS RECIPIENT NAME
    47   R  M         N   N      0        NA       ORIGINAL-INTENDED-RECIP-NM
    48   R  M         N   N      0        NA       CONVERTED-ENCODE-INFO-TYPES
    49   R  M         N   N      0        NA       MESSAGE SUBMISSION TIME
    50   R  M         N   N      0        NA       CONTENT ID
    51   R  M         N   N      0        NA       EXTENSIONS
    52   R  M         N   N      0        NA       MULTI RECIP, SEQ OF RCP INFO
    53   R  M         N   N      0        NA       DELIVERY TIME



(* CONTROL ATTRIBUTES - ie. NOT PARTS OF THE P2 MESSAGE                      *)


    60   R  M         N   N      0        NA       OBJECT STATUS - BITSRING
(*                                                    BIT 0 = 1 => P2 DECODED
(*                                                    BIT 1 = 1 => APDU VALID
    65  RW  M         N   N      0        NA       BODY PARTS
    66  RW  M         N   N      0        NA       BODY PARTS
    67  RW  M         N   N      0        NA       BODY PARTS
    68  RW  M         N   N      0        NA       BODY PARTS
    69  RW  M         N   N      0        NA       BODY PARTS
    70  RW  M         N   N      0        NA       BODY PARTS
    71  RW  M         N   N      0        NA       BODY PARTS
    72  RW  M         N   N      0        NA       BODY PARTS
    73  RW  M         N   N      0        NA       BODY PARTS
    74  RW  M         N   N      0        NA       BODY PARTS
    75  RW  M         N   N      0        NA       BODY PARTS
    76  RW  M         N   N      0        NA       BODY PARTS

    82  UP  M         N   N      0        NA       SCRATCH ATTRIB FOR XAPI
    90  RW  S         N   Y      0        NA       XAPI OM OBJECT CLASS
    92  R   S         N   Y      0        NA       OBJECT USAGE COUNT


END OF OBJECT CLASS

(* ------------------------------------------------------------------------- *)
(* OBJECT CLASS 14 IS FOR THE DBS REGRESSION                                 *)
(* ------------------------------------------------------------------------- *)
OBJECT CLASS ID = 14
DIRECT COPY LIM = 100

(* ATTR | Single | Indexed | Reserved | Masking | Comment                    *)
(*  ID  | Multi  |   Y/N   |   Size   |   op    |                            *)
(*   ________         __________                                             *)
(*   | TYPE |         | INIT ? |                                             *)
(*   |      |         |        |                                             *)

    3   UP  S         N   N      0        NA
    4   UP  S         N   N      0        NA
    5   UP  S         N   N      0        NA
    6   UP  S         N   N      0        NA
    7   UP  M         N   N      0        NA
    8   UP  M         N   N      0        NA
    24  UP  M         N   N      0        NA

END OF OBJECT CLASS

(* ------------------------------------------------------------------------- *)
!
