(* $Workfile:   x500.tpl  $ $Revision:   3.3  $ *)
(* DIRECTORY.TPL *)
(*****************************************************************************)
(* ASN.1 DIRECTORY DATA-TYPE TEMPLATE                                        *)
(*                                                                           *)
(*   Initial template based on X.501 Directory Name definition               *)
(*     - update/rework as neccessary                                         *)
(*                                                                           *)
(* Known simplifications:                                                    *)
(*   - setting of 'E' for ENCODE calls to signify COLLECT calls to User      *)
(*   - setting of 'D' for DECODE calls to signify CONSULT calls to User      *)
(*   - setting of 'S' for potential constructor octet primitives             *)
(*****************************************************************************)

(*****************************************************************************)
(* Directory name - based on X.501                                           *)
(*****************************************************************************)

DirectoryName              LABEL     = Ddirn
                           STRUCTURE = CHOICE
                           CHILDREN  = { <Drdns, U 16 C,M,0> }

RDNSequence                LABEL     = Drdns
                           STRUCTURE = SEQUENCE OF
                           LIMIT     = 0
                           CHILDREN  = { <Drdnm, U 17 C,M,0> E }

RelativeDistinguishedName  LABEL     = Drdnm
                           STRUCTURE = SET OF
                           LIMIT     = 0
                           CHILDREN  = { <Davas, U 16 C,M,0> E }

AttributeValueAssertion    LABEL     = Davas
                           STRUCTURE = SEQUENCE
                           CHILDREN  = { <Cobid, U  6 P,M,0>,
                                         <Datrv, U  0 P,M,0> }

AttributeValue             LABEL     = Datrv
                           STRUCTURE = ANY
                           CHILDREN  = {}

!
