(* X5OOATTR.TPL *)
(*****************************************************************************)
(* ASN.1 X.500 Attribute Syntaxes                                            *)
(*****************************************************************************)


(*****************************************************************************)
(* BDCP DEFINITIONS                                                          *)
(*****************************************************************************)

Aliased Object Name        LABEL     = 5aobn
                           STRUCTURE = SEQUENCE OF
                           CHILDREN  = { <5rldn, U 17 C,O,0> }

Auth_Revocation List       LABEL     = 5arlt
                           STRUCTURE = SEQUENCE
                           CHILDREN  = { <5sign, U 16 C,M,0> ,
                                         <5issu, U  0 P,M,0> ,
                                         <5lstu, U 23 P,M,0> ,
                                         <5rvks, U 16 C,M,0> }

Business Category          LABEL     = 5cisy
                           STRUCTURE = CHOICE
                           CHILDREN  = { <5cisp, U 19 P,O,0> ,
                                         <5cist, U 20 P,O,0> }

Case Ignore Syntax (P)     LABEL     = 5cisp
                           STRUCTURE = PRINTABLE STRING

Case Ignore Syntax (T)     LABEL     = 5cist
                           STRUCTURE = TELETEX STRING

CA Certificate             LABEL     = 5cact
                           STRUCTURE = SEQUENCE
                           CHILDREN  = { <5vern, C  0 P,D,0> ,
                                         <5srln, U  2 P,M,0> ,
                                         <5sign, U 16 C,M,0> ,
                                         <5issu, U  0 P,M,0> ,
                                         <5vldy, U 16 C,M,0> ,
                                         <5subj, U  0 P,M,0> ,
                                         <5spki, U 16 C,M,0> }

Cert_Revocation List       LABEL     = 5crlt
                           STRUCTURE = SEQUENCE
                           CHILDREN  = { <5sign, U 16 C,M,0> ,
                                         <5issu, U  0 P,M,0> ,
                                         <5lstu, U 23 P,M,0> ,
                                         <5rvks, U 16 C,M,0> }

Common Name                LABEL     = 5cnme
                           STRUCTURE = CHOICE
                           CHILDREN  = { <5cisp, U 19 P,O,0> ,
                                         <5cist, U 20 P,O,0> }

Country Name               LABEL     = 5cynm
                           STRUCTURE = PRINTABLE STRING

Cross Certificate Pair     LABEL     = 5ccpr
                           STRUCTURE = SEQUENCE
                           CHILDREN  = { <5frwd, C  0 C,O,0> ,
                                         <5rvrs, C  1 C,O,0> }

Description                LABEL     = 5drpn
                           STRUCTURE = CHOICE
                           CHILDREN  = { <5cisp, U 19 P,O,0> ,
                                         <5cist, U 20 P,O,0> }

Destination Indicator      LABEL     = 5dind
                           STRUCTURE = PRINTABLE STRING

Facsimile Telephone No.    LABEL     = 5ftel
                           STRUCTURE = SEQUENCE
                           CHILDREN  = { <5tnum, U 19 P,O,0> ,
                                         <5g3nb, U 20 P,O,0> }

G3 Non Basic Parameters    LABEL     = 5g3nb
                           STRUCTURE = ANY
                           CHILDREN  = { }

International ISDN No.     LABEL     = 5isdn
                           STRUCTURE = NUMERIC STRING

Knowledge Information      LABEL     = 5ninf
                           STRUCTURE = CHOICE
                           CHILDREN  = { <5cisp, U 19 P,O,0> ,
                                         <5cist, U 20 P,O,0> }

Locality Name              LABEL     = 5lnam
                           STRUCTURE = CHOICE
                           CHILDREN  = { <5cisp, U 19 P,O,0> ,
                                         <5cist, U 20 P,O,0> }

Member                     LABEL     = 5mmbr
                           STRUCTURE = SEQUENCE OF
                           CHILDREN  = { <5rldn, U 17 C,O,0> }

Object Class               LABEL     = 5ocla
                           STRUCTURE = OBJECT IDENTIFIER

Organisation Name          LABEL     = 5onam
                           STRUCTURE = CHOICE
                           CHILDREN  = { <5cisp, U 19 P,O,0> ,
                                         <5cist, U 20 P,O,0> }

Organisational Unit Name   LABEL     = 5ounm
                           STRUCTURE = CHOICE
                           CHILDREN  = { <5cisp, U 19 P,O,0> ,
                                         <5cist, U 20 P,O,0> }

Owner                      LABEL     = 5ownr
                           STRUCTURE = SEQUENCE OF
                           CHILDREN  = { <5rldn, U 17 C,O,0> }

Physical Delivery Office   LABEL     = 5pdon
                           STRUCTURE = CHOICE
                           CHILDREN  = { <5cisp, U 19 P,O,0> ,
                                         <5cist, U 20 P,O,0> }

Post Office Box            LABEL     = 5pobx
                           STRUCTURE = CHOICE
                           CHILDREN  = { <5cisp, U 19 P,O,0> ,
                                         <5cist, U 20 P,O,0> }

Postal Address             LABEL     = 5padr
                           STRUCTURE = SEQUENCE OF
                           CHILDREN  = { <5pach, U  0 P,O,0> }

Postal Address Item        LABEL     = 5pach
                           STRUCTURE = CHOICE
                           CHILDREN  = { <5cisp, U 19 P,O,0> ,
                                         <5cist, U 20 P,O,0> }

Postal Code                LABEL     = 5pcde
                           STRUCTURE = CHOICE
                           CHILDREN  = { <5cisp, U 19 P,O,0> ,
                                         <5cist, U 20 P,O,0> }

Preferred Delivery Method  LABEL     = 5dmth
                           STRUCTURE = INTEGER

PresentationAddress        LABEL     = 5padd
                           STRUCTURE = SEQUENCE
                           CHILDREN  = { <5psel, C 0 S,O,0>,
                                         <5ssel, C 1 S,O,0>,
                                         <5tsel, C 2 S,O,0>,
                                         <5neta, C 3 C,M,0> }

pSelector                  LABEL     = 5psel
                           STRUCTURE = OCTETSTRING

sSelector                  LABEL     = 5ssel
                           STRUCTURE = OCTETSTRING

tSelector                  LABEL     = 5tsel
                           STRUCTURE = OCTETSTRING

nAddresses                 LABEL     = 5neta
                           STRUCTURE = SEQUENCE OF
                           CHILDREN  = { <5nsqo, U 4 S,O,0> }

nAddressString             LABEL     = 5nsqo
                           STRUCTURE = OCTETSTRING

Registered Address         LABEL     = 5radr
                           STRUCTURE = SEQUENCE OF
                           CHILDREN  = { <5pach, U  0 P,O,0> }

Role Occupant              LABEL     = 5rocc
                           STRUCTURE = SEQUENCE OF
                           CHILDREN  = { <5rldn, U 17 C,O,0> }

Search Guide               LABEL     = 5sgid
                           STRUCTURE = CHOICE
                           CHILDREN  = { <5ctyp, C  0 C,O,0>,
                                         <5cand, C  1 C,O,0>,
                                         <5cror, C  2 C,O,0>,
                                         <5sgid, C  3 C,O,0>  }

CriteriaItem               LABEL     = 5ctyp
                           STRUCTURE = CHOICE
                           TAG       = (C 0 C)
                           CHILDREN  = { <5eqal, C  0 C,O,0>,
                                         <5sbst, C  1 C,O,0>,
                                         <5goeq, C  2 C,O,0>,
                                         <5loeq, C  3 C,O,0>,
                                         <5aprx, C  4 C,O,0>  }

Equality                   LABEL     = 5eqal
                           STRUCTURE = OBJECT IDENTIFIER

Substrings                 LABEL     = 5sbst
                           STRUCTURE = OBJECT IDENTIFIER

GreaterOrEqual             LABEL     = 5goeq
                           STRUCTURE = OBJECT IDENTIFIER

LessOrEqual                LABEL     = 5loeq
                           STRUCTURE = OBJECT IDENTIFIER

Approximate Match          LABEL     = 5aprx
                           STRUCTURE = OBJECT IDENTIFIER

and                        LABEL     = 5cand
                           STRUCTURE = SET OF
                           CHILDREN  = { <5sgid, U  0 P,O,0> }

or                         LABEL     = 5cror
                           STRUCTURE = SET OF
                           CHILDREN  = { <5sgid, U  0 P,O,0> }

See Also                   LABEL     = 5also
                           STRUCTURE = SEQUENCE OF
                           CHILDREN  = { <5rldn, U 17 C,O,0> }

State or Province Name     LABEL     = 5sopn
                           STRUCTURE = CHOICE
                           CHILDREN  = { <5cisp, U 19 P,O,0> ,
                                         <5cist, U 20 P,O,0> }

Street Address             LABEL     = 5stad
                           STRUCTURE = CHOICE
                           CHILDREN  = { <5cisp, U 19 P,O,0> ,
                                         <5cist, U 20 P,O,0> }

Supported Application Cxt  LABEL     = 5sapx
                           STRUCTURE = OBJECT IDENTIFIER

Surname                    LABEL     = 5snme
                           STRUCTURE = CHOICE
                           CHILDREN  = { <5cisp, U 19 P,O,0> ,
                                         <5cist, U 20 P,O,0> }

Telephone Number           LABEL     = 5tnum
                           STRUCTURE = PRINTABLE STRING

Telex Terminal Identifier  LABEL     = 5ttid
                           STRUCTURE = SEQUENCE
                           CHILDREN  = { <5ttps, U 19 P,O,0> ,
                                         <5tnbp, U  0 P,O,0> }

Telex Term. Printable Str. LABEL     = 5ttps
                           STRUCTURE = PRINTABLE STRING

Telex Term. NB Parms       LABEL     = 5tnbp
                           STRUCTURE = ANY
                           CHILDREN  = { }

Telex Number               LABEL     = 5txnm
                           STRUCTURE = SEQUENCE
                           CHILDREN  = { <5tnps, U 19 P,O,0> ,
                                         <5tncc, U 19 P,O,0> ,
                                         <5tnab, U 19 P,O,0> }

Telex Numb. Printable Str. LABEL     = 5tnps
                           STRUCTURE = PRINTABLE STRING

Country Code               LABEL     = 5tncc
                           STRUCTURE = PRINTABLE STRING

AnswerBack                 LABEL     = 5ttab
                           STRUCTURE = PRINTABLE STRING

Title                      LABEL     = 5titl
                           STRUCTURE = CHOICE
                           CHILDREN  = { <5cisp, U 19 P,O,0> ,
                                         <5cist, U 20 P,O,0> }

User Certificate           LABEL     = 5ucrt
                           STRUCTURE = SEQUENCE
                           CHILDREN  = { <5vern, C  0 P,D,0> ,
                                         <5srln, U  2 P,M,0> ,
                                         <5sign, U 16 C,M,0> ,
                                         <5issu, U  0 P,M,0> ,
                                         <5vldy, U 16 C,M,0> ,
                                         <5subj, U  0 P,M,0> ,
                                         <5spki, U 16 C,M,0> }

User Password              LABEL     = 5upsw
                           STRUCTURE = OCTET STRING

X.121 Address              LABEL     = 5xadd
                           STRUCTURE = NUMERIC STRING

!
