<%
'!--Microsoft Outlook Web Access-->
'!--Render.inc - Basinc Rendering functions-->
'!--Copyright (c) Microsoft Corporation 1993-1997. All rights reserved.-->
'===CONTENTS========================
' GetRenderer
' GetTableRenderer
' GetObjectRenderer
' GetMessageRenderer
' GetWhenField
' GetPlainBodyText
'========================

'=======================
' GetRenderer
' nType is AMHTML object class (Application, Object, Container)
' Returns: rendering object for tables
'=======================
Public Function GetRenderer(bstrRenderer, nType, ByRef fNew)
    On Error Resume Next
    
    Set GetRenderer = Nothing

    fNew = False

    If IsEmpty(Session(bstrRenderer)) Then
        Set objRenderer = Nothing
    Else
        Set objRenderer = Session(bstrRenderer)
    End If

    If objRenderer Is Nothing Then
        Err.Clear

        Set objRenderApp = Application(bstrRenderApp)
        If objRenderApp Is Nothing Then
            ReportError1 L_errFailedToCreateApp_ErrorMessage
        End If
        
        Set objRenderer = objRenderApp.CreateRenderer(nType)
        If objRenderer Is Nothing Then
            ReportError1 L_errFailedToCreateApp_ErrorMessage
        End If

        Set Session(bstrRenderer) = objRenderer
        
        ' set the language
        objRenderer.CodePage = Request.ServerVariables("HTTP_ACCEPT_LANGUAGE")

        fNew = True
    End If
    
    Set GetRenderer = objRenderer

End Function

'=======================
' GetTableRenderer
'
' Returns: rendering object tables
'=======================
Public Function GetTableRenderer(bstrRenderer, ByRef fNew)
    On Error Resume Next
    
    Set GetTableRenderer = Nothing
    
    Set objRenderer = GetRenderer(bstrRenderer, AMHTML_Class_ContainerRenderer, fNew)

    If (Not objRenderer Is Nothing) Then
        If fNew Then
            ' cache the private store, if there is one
            If (Session(bstrAuthenticated)) Then
                objRenderer.PrivateStore = objOMSession.GetInfoStore(objOMSession.Inbox.StoreID)
                If (Err.Number <> 0) Then
                    ReportError1 L_errFailedToGetInbox_ErrorMessage
                End If

            End If
        End If
    End If

    Set GetTableRenderer = objRenderer
End Function

'=======================
' GetObjectRenderer
'
' Returns: rendering object for Object
'=======================
Public Function GetObjectRenderer
    On Error Resume Next
    
    Set GetObjectRenderer = GetRenderer(bstrRenderObject, AMHTML_Class_ObjectRenderer, fNew)
End Function

'=======================
' GetMessageRenderer
'
' Returns: rendering object for Message
'=======================
Public Function GetMessageRenderer
    On Error Resume Next

    Set objRenderer = GetRenderer(bstrRenderMessage, AMHTML_Class_ObjectRenderer, fNew)
    If (Not objRenderer Is Nothing) Then

        If fNew Then
            Set objFormat = objRenderer.Formats.Add(ActMsgPR_IMPORTANCE, Null)
            If (Err.Number <> 0) Then
                ReportError1 L_errFailAddFormat_ErrorMessage
            Else
                objFormat.Patterns.Add 0, L_Low_StaticText
                objFormat.Patterns.Add 1, L_Normal_StaticText
                objFormat.Patterns.Add 2, L_High_StaticText
            End If

            objRenderer.LinkPattern = bstrVirtRoot + "/forms/%classpath%frmroot.asp?obj=%obj%&command=open"
        End If

    End If

    Set GetMessageRenderer = objRenderer
End Function


'==========================================================
' GetWhenField
' Construct the "When" string base on StartTime and EndTime
'==========================================================

Public Function GetWhenField( objRenderer, objOneMsg)
	On Error Resume Next

	'Cannot use the AllDayEvent property because AM set it to
	'True all the time
	Set objAppt = objOneMsg.GetAssociatedAppointment
	'allDayEvent = objAppt.AllDayEvent

	GetWhenField = ""

	If abs(objOMSession.GetOption("Is24HourClock")) Then
		bstrTimeFormat = L_WhenTime1_Text
	Else
		bstrTimeFormat = L_WhenTime_Text
	End If
	
	If objAppt.IsRecurring Then		'if the event is recurring
		
		' In case of a recurring event, the general form of the When field is as follows.
		' "Occurs" + bstrPattern + "effective" + StartDate + "until" + EndDate 
		'                                + "from" + StartTime + "to" + EndTime

		'Days of week (for the 'When' field)
		const olEveryday	= 127	'=olSunday + olMonday + olTuesday + olWednesday + olThursday +
									'	olFriday + olSaturday
		const olWeekdays	= 62	'=olMonday + olTuesday + olWednesday + olThursday + olFriday
		const olWeekendDays = 65	'=olSunday + olSaturday

		dim aDays(7)
		aDays(0)=L_Sunday_Text	
		aDays(1)=L_Monday_Text	
		aDays(2)=L_Tuesday_Text	
		aDays(3)=L_Wednesday_Text
		aDays(4)=L_Thursday_Text	
		aDays(5)=L_Friday_Text	
		aDays(6)=L_Saturday_Text	

		dim aMonths(12)
		aMonths(0)=L_Jan_Text
		aMonths(1)=L_Feb_Text
		aMonths(2)=L_Mar_Text
		aMonths(3)=L_Apr_Text
		aMonths(4)=L_May_Text
		aMonths(5)=L_Jun_Text
		aMonths(6)=L_Jul_Text
		aMonths(7)=L_Aug_Text
		aMonths(8)=L_Sep_Text
		aMonths(9)=L_Oct_Text
		aMonths(10)=L_Nov_Text
		aMonths(11)=L_Dec_Text
		
		dim aOrdinals(5)
		aOrdinals(0)=L_When_Field_First_Text
		aOrdinals(1)=L_When_Field_Second_Text
		aOrdinals(2)=L_When_Field_Third_Text
		aOrdinals(3)=L_When_Field_Fourth_Text
		aOrdinals(4)=L_When_Field_Last_Text		
		
		Set objPat		= objAppt.GetRecurrencePattern
		tStartTime      = objPat.StartTime
		tEndTime        = objPat.EndTime
		nRecur          = objPat.RecurrenceType 
		nInterval       = objPat.Interval 
		nDayOfWeekMask  = objPat.DayOfWeekMask 
		nInstance       = objPat.Instance 
		nMonthOfYear    = objPat.MonthOfYear
		nDayOfMonth     = objPat.DayOfMonth 
		nPatStartDate   = objPat.PatternStartDate
		nPatEndDate     = objPat.PatternEndDate
		iDuration       = objPat.Duration 
		
		bstrPattern = " "

		if nRecur = ActMsgRecurTypeDaily Then				' if the event recurs daily
				
			if nInterval = 1 Then 
				bstrPattern = L_When_Field_Every_Text & " " & L_When_Field_Day_Text
			Else
				bstrPattern = L_When_Field_Every_Text & " " & nInterval & " " & L_When_Field_Days_Text
			End If

		ElseIf nRecur = ActMsgRecurTypeWeekly Then			' if the event recurs weekly
				
			if nInterval = 1 Then 
				bstrPattern = L_When_Field_Every_Text & " "
			Else
				bstrPattern = L_When_Field_Every_Text & " " & nInterval & " " &_
								L_When_Field_WeeksOn_Text & " "
			End If

			nMask = nDayOfWeekMask
			bstrDaysOfWeek = ""
			nCtr =0 
				
			If nMask = olWeekdays Then	' occurs every weekday
				bstrDaysOfWeek = L_When_Field_WeekDay_Text
			Else
					
				' $ sign used a delimiter, for further processing
				if nMask and olSunday    Then bstrDaysOfWeek = bstrDaysOfWeek & L_Sunday_Text	& "$" : nCtr=nCtr + 1
				if nMask and olMonday    Then bstrDaysOfWeek = bstrDaysOfWeek & L_Monday_Text	& "$" : nCtr=nCtr + 1
				if nMask and olTuesday   Then bstrDaysOfWeek = bstrDaysOfWeek & L_Tuesday_Text	& "$" : nCtr=nCtr + 1
				if nMask and olWednesday Then bstrDaysOfWeek = bstrDaysOfWeek & L_Wednesday_Text & "$" : nCtr=nCtr + 1
				if nMask and olThursday  Then bstrDaysOfWeek = bstrDaysOfWeek & L_Thursday_Text	& "$" : nCtr=nCtr + 1
				if nMask and olFriday    Then bstrDaysOfWeek = bstrDaysOfWeek & L_Friday_Text	& "$" : nCtr=nCtr + 1
				if nMask and olSaturday  Then bstrDaysOfWeek = bstrDaysOfWeek & L_Saturday_Text	& "$" : nCtr=nCtr + 1
				
				bstrDaysOfWeek = Left(bstrDaysOfWeek, Len(bstrDaysOfWeek)-1)
				
			End If				

			if nCtr = 2 Then
				bstrDaysOfWeek = Replace(bstrDaysOfWeek, "$", " and ")					
			ElseIf nCtr > 2 Then
				bstrDaysOfWeek = Replace(bstrDaysOfWeek, "$", ", ",1, nCtr-2)
				bstrDaysOfWeek = Replace(bstrDaysOfWeek, "$", ", and ")					
			End If

			bstrPattern = bstrPattern & bstrDaysOfWeek

		ElseIf nRecur = ActMsgRecurTypeMonthly Then				' if the event recurs monthly

			bstrPattern = L_When_Field_Day_Text & " " & nDayOfMonth & " " & L_When_Field_OfEvery_Text &_ 
								" " & nInterval & " " & L_When_Field_Months_Text & " "

		ElseIf nRecur = ActMsgRecurTypeMonthlyNth Then			' if the event recurs monthly (nth)
				
			bstrDaysOfWeek = ""
			nMask = nDayOfWeekMask
				
			if nMask = bstrPattern Then		' every day
				bstrDaysOfWeek = L_When_Field_Day_Text
			ElseIf nMask = olWeekdays Then	' every weekday
				bstrDaysOfWeek = L_When_Field_WeekDay_Text
			ElseIf nMask = olWeekendDays Then	' every weekend day
				bstrDaysOfWeek = L_When_Field_WeekendDay_Text
			Else
				if nMask and olSunday    Then bstrDaysOfWeek = L_Sunday_Text 
				if nMask and olMonday    Then bstrDaysOfWeek = L_Monday_Text 
				if nMask and olTuesday   Then bstrDaysOfWeek = L_Tuesday_Text
				if nMask and olWednesday Then bstrDaysOfWeek = L_Wednesday_Text
				if nMask and olThursday  Then bstrDaysOfWeek = L_Thursday_Text
				if nMask and olFriday    Then bstrDaysOfWeek = L_Friday_Text 
				if nMask and olSaturday  Then bstrDaysOfWeek = L_Saturday_Text
			End If

			bstrPattern = L_When_Field_The_Text & " " & aOrdinals(nInstance-1) &_ 
							" " & bstrDaysOfWeek & " " & L_When_Field_OfEvery_Text &_ 
							" " & nInterval & " " & L_When_Field_Months_Text & " "

		ElseIf nRecur = ActMsgRecurTypeYearly Then				' if the event recurs yearly

			bstrPattern = L_When_Field_Every_Text & " " & aMonths(nMonthOfYear-1) & " " & nDayOfMonth

		ElseIf nRecur = ActMsgRecurTypeYearlyNth Then			' if the event recurs yearly (nth)

			bstrDaysOfWeek = ""
			nMask = nDayOfWeekMask
				
			if nMask = bstrPattern Then		' every day
				bstrDaysOfWeek = L_When_Field_Day_Text
			ElseIf nMask = olWeekdays Then	' every weekday
				bstrDaysOfWeek = L_When_Field_WeekDay_Text
			ElseIf nMask = olWeekendDays Then	' every weekend day
				bstrDaysOfWeek = L_When_Field_WeekendDay_Text
			Else
				if nMask and olSunday    Then bstrDaysOfWeek = L_Sunday_Text 
				if nMask and olMonday    Then bstrDaysOfWeek = L_Monday_Text 
				if nMask and olTuesday   Then bstrDaysOfWeek = L_Tuesday_Text
				if nMask and olWednesday Then bstrDaysOfWeek = L_Wednesday_Text
				if nMask and olThursday  Then bstrDaysOfWeek = L_Thursday_Text
				if nMask and olFriday    Then bstrDaysOfWeek = L_Friday_Text 
				if nMask and olSaturday  Then bstrDaysOfWeek = L_Saturday_Text
			End If

			bstrPattern = L_When_Field_The_Text & " " & aOrdinals(nInstance-1) & " " &_ 
							bstrDaysOfWeek & " of " & aMonths(nMonthOfYear-1)

		End if

		if objPat.NoEndDate Then 
			bstrUntilString = " "
		Else
			bstrUntilString = " " & L_When_Field_Until_Text & " " &_ 
								objRenderer.RenderDate(nPatEndDate, L_WhenDate1_Text) & " "
		End If
		
		nNumOfDays = DateValue(tEndTime) - DateValue(tStartTime)

		if nNumOfDays = 0 Then				'meeting occurs on one day
			bstrToString = " " & "to" & " " & objRenderer.RenderTime( nPatEndDate, bstrTimeFormat) 
		ElseIf nNumOfDays = 1 Then			' a one day event
			bstrToString = " " & L_When_Field_For1Day_Text
		ElseIf nNumOfDays = 2 Then			' a two day event
			bstrToString = " " & L_When_Field_For2Days_Text
		End If 

		bstrWhen = L_When_Field_Occurs_Text & " " & bstrPattern & " " & L_When_Field_Effective_Text & " " &_
					objRenderer.RenderDate(nPatStartDate, L_WhenDate1_Text)  &_
					bstrUntilString & L_When_Field_From_Text & " "  &_ 
					objRenderer.RenderTime( tStartTime, bstrTimeFormat)  & bstrToString
		
	Else			'if the event is not recurring
		
		Set objFields = objOneMsg.Fields

		Set objStartTime = objFields.Item(ActMsgPR_START_DATE)
		Set objEndTime = objFields.Item(ActMsgPR_END_DATE)

		pos = Instr(objStartTime, ":")
		If pos = 0 Then
			allDayEvent = True
		Else
			allDayEvent = False
		End If

		If allDayEvent = True Then
			bstrWhen = objRenderer.RenderDate( objStartTime, L_WhenDate_Text) & ", " & L_AllDayEvent_StaticText
		Else

			If DateValue( objStartTime) = DateValue( objEndTime) Then
				'meeting occurs on one day
				bstrWhen = objRenderer.RenderDate( objStartTime, L_WhenDate_Text) & " " & _
							objRenderer.RenderTime( objStartTime, bstrTimeFormat) & " - " & _
							objRenderer.RenderTime( objEndTime, bstrTimeFormat)
			Else
				'meeting last more than one day, but not an all day event
				bstrWhen = objRenderer.RenderDate( objStartTime, L_WhenDate_Text) & " " & _
							objRenderer.RenderTime( objStartTime, bstrTimeFormat) & " - " & _
							objRenderer.RenderDate( objEndTime, L_WhenDate_Text) & " " & _
							objRenderer.RenderTime( objEndTime, bstrTimeFormat)
			End If

		End If

	End If

	GetWhenField = bstrWhen

End Function

Function GetPlainBodyText(objMsg)
    On Error Resume Next
    bstrText = objMsg.Text
    If isMSIE then
        If isMac then
            If getVersion() < 4 then
    	        bstrText = Replace(bstrText,vbCRLF, chr(13))
            End If
        End If
    End If
    GetPlainBodyText = bstrText
End Function

%>
